=== debian/changelog ===
postgresql-pllua (1:2.0.12-6) unstable; urgency=medium

  * Upload for PostgreSQL 18. (Closes: #1117325)
  * Add ${postgresql:Breaks}.
  * debian/tests: Depend on postgresql-common-dev instead of 'make'.

 -- Christoph Berg <myon@debian.org>  Wed, 08 Oct 2025 19:48:04 +0200

postgresql-pllua (1:2.0.12-5) unstable; urgency=medium

  * Support PostgreSQL 18.

 -- Christoph Berg <myon@debian.org>  Mon, 28 Apr 2025 09:59:45 +0000

postgresql-pllua (1:2.0.12-4) unstable; urgency=medium

  * Mark lua object as not needing an executable stack. (Closes: #1096038)

 -- Christoph Berg <myon@debian.org>  Fri, 28 Feb 2025 14:31:37 +0100

postgresql-pllua (1:2.0.12-3) unstable; urgency=medium

  * Upload for PostgreSQL 17.
  * Restrict to 64-bit architectures.
  * Mark postgresql-all as <!nocheck>.

 -- Christoph Berg <myon@debian.org>  Sat, 14 Sep 2024 23:40:03 +0200

postgresql-pllua (1:2.0.12-2) unstable; urgency=medium

  * Upload for PostgreSQL 16.

 -- Christoph Berg <myon@debian.org>  Mon, 18 Sep 2023 19:34:58 +0000

postgresql-pllua (1:2.0.12-1) unstable; urgency=medium

  * New upstream version with PG16 support.

 -- Christoph Berg <myon@debian.org>  Sat, 29 Jul 2023 21:25:57 +0200
