=== debian/tests/control ===
Depends:
 lua5.3,
 postgresql-common-dev,
 @,
Test-Command: LUA=lua5.3 pg_buildext installcheck
Restrictions:
 allow-stderr,
Features:
 test-name=installcheck-pllua,

Depends:
 postgresql-all,
 postgresql-common-dev,
 @,
Test-Command: pg_buildext installcheck hstore
Restrictions:
 allow-stderr,
Features:
 test-name=installcheck-pllua-hstore,
